
#include <proto/exec.h>
#include <proto/dos.h>
#include <proto/intuition.h>
#include <proto/datatypes.h>
#include <clib/alib_protos.h>
#include <datatypes/soundclass.h>

struct note {
	char *name;
	long mult;
	} note[] = {
	{"C-1",20000},
	{"C#1",18877},
	{"D-1",17817},
	{"D#1",16817},
	{"E-1",15874},
	{"F-1",14983},
	{"F#1",14142},
	{"G-1",13348},
	{"G#1",12599},
	{"A-1",11892},
	{"A#1",11224},
	{"H-1",10594},
	{"C-2",10000}
	};

short melody[] = {
	 0,37,	/* note, delay */
	 4,12,
	 7,25,
	12,25,
	 9,25,
	12,12,
	 9,12,
	 7,50,
	 5,37,
	 7,12,
	 4,25,
	 0,25,
	 2,50,
	 0,25,
	-1,25,	/* -1 = silent */
	 7,25,
	 7,25,
	 5,25,
	 5,25,
	 4,25,
	 7,12,
	 4,12,
	 2,50,
	 7,25,
	 7,25,
	 5,25,
	 5,25,
	 4,25,
	 7,12,
	 4,12,
	 2,50,
	 0,37,
	 4,12,
	 7,25,
	12,25,
	 9,25,
	12,12,
	 9,12,
	 7,50,
	 5,37,
	 7,12,
	 4,25,
	 0,25,
	 2,50,
	 0,25,
	-2,50,	/* -2 = end */
	};


int main (int argc,char **argv)

{
char *name = "Sys:Prefs/Presets/Beeps/Simple/Xylophone.snd";
Object *o;

if (argc > 1)
	name = argv[1];

if (o = NewDTObject (name,DTA_GroupID,GID_SOUND,TAG_END))
	{
	long n,d;
	short *p = melody;
	ULONG period = 394;

	GetAttr (SDTA_Period,o,&period);

	Printf ("period = %ld\n",period);

	do	{
		n = *p++;
		d = *p++;

		if (n >= 0)
			{
			Printf ("%s\n",note[n].name);
			SetAttrs (o,SDTA_Period,period * note[n].mult / 20000,TAG_END);
			DoMethod (o,DTM_TRIGGER,NULL,STM_PLAY,NULL);
			}
		else
			Printf ("--\n");

		Delay (d);

		if (SetSignal (0,0) & SIGBREAKF_CTRL_C)
			break;
		}
	while (n != -2);

	DisposeDTObject (o);
	}

PrintFault (IoErr(),name);

return (0);
}

